import java.util.Hashtable;
import java.awt.Color;

/*
 * IOSystem.java
 *
 * Created on 10 July 2002, 09:57
 */

/**
 * Pretends to be the IO subsystem of the OS.
 * Is used for calls for input or output.
 * Is also called when a process has finished.
 *
 * @author
 */
public class IOSystem {

    /**
     * Sets the selected process.
     * The selected process is the one that gets sent key presses.
     * If the parameter is null the current selected process is unselected.
     * @param selected the selected process
     */
    public static void setSelectedProcess(A1Process selected) {
    }

    /**
     * Called by a process when it wants a line from the keyboard.
     * Blocks the process until a newline '\n'  is typed.
     * @param requestingProcess the requesting process
     * @return the line of typed text.
     */
    public static String readLine(A1Process requestingProcess) {
     /**
      insert some here !!!
     **/
     return "";
    }

    /**
     * Puts a character into the buffer of the currently selected process.
     * This gets displayed on the screen immediately even though the process
     * stays waiting until the newline is received.
     * If the character was a newline the input is ready and the process can
     * return from the readLine method and run again.
     * @param c the character
     */
    public static void putChar(char c) {
    }

    /**
     * Called by a process when it wants to display output in its text area.
     * This doesn't block the process.
     * @param requestingProcess the requesting process
     * @param output the string to display
     */
    public static void print(A1Process requestingProcess, String output) {
        requestingProcess.getOutputArea().getTextArea().append(output);
    }

    /**
     * Sets the dispatcher.
     * The IOSystem needs a reference to the dispatcher.
     * @param d the dispatcher
     */
    public static void setDispatcher(Dispatcher d) {
    }

    /**
     * Informs the dispatcher that a process has finished.
     * Also puts "---- finished ----" into the process display.
     * @param process the finished process
     */
    public static void exit(A1Process process) {
    
    }

}
